#include "function_reg.h"
#include <stdlib.h>
#include <string.h>
#include <assert.h>
#include <dlfcn.h>
#include <link.h>

void add_function(FunctionRegistry* freg, Function* f) {
   FunctionRegistryEntry* entry = malloc(sizeof(FunctionRegistryEntry));
   assert(entry);
   entry->f = f;
   entry->next = freg->entries; freg->entries = entry;
}

Function* lookup(FunctionRegistry* freg, char* name) {
   FunctionRegistryEntry* entry = freg->entries;
   while (entry && strcmp(entry->f->name, name)) {
      entry = entry->next;
   }
   if (entry) return entry->f;

   // attempt to load it dynamically
   size_t sofile_len = strlen(name) + 5;
   char* sofile = malloc(sofile_len); assert(sofile);
   strcpy(sofile, "./"); strcat(sofile, name); strcat(sofile, ".so");
   void* handle = dlopen(sofile, RTLD_LAZY | RTLD_LOCAL);
   if (!handle) return 0;
   Function* (*gf)() = (Function* (*)()) dlsym(handle, "get_function");
   if (!gf) {
      dlclose(handle); return 0;
   }
   Function* f = gf();
   add_function(freg, f);
   return f;
}
