#include <stdio.h>
#include <stdbool.h>
#include <ctype.h>
#include "function.h"
#include "function_reg.h"

bool read_fname(char* buf, size_t buflen) {
   if (buflen <= 0) return false;
   int ch;
   bool start = true;
   size_t count = 0;
   while ((ch = getchar()) != EOF && count + 1 < buflen) {
      if (start) {
	 if (isspace(ch)) continue;
	 start = false;
      }
      if (isspace(ch)) break;
      buf[count++] = ch;
   }
   if (count == 0) return false;
   buf[count] = 0; return true;
}

int main() {
   FunctionRegistry freg = {0};

   for(;;) {
      printf(": ");
      char fname[32];
      double x = 0;
      if (!read_fname(fname, sizeof fname)) break;
      if (scanf("%lf", &x) != 1) break;
      Function* f = lookup(&freg, fname);
      if (f) {
	 double result = execute(f, x);
	 printf("%g\n", result);
      } else {
	 printf("no such function: %s\n", fname);
      }
   }
}
